######################################################################
# zwiki page and zwiki web creation

from types import *
from urllib import quote
from Globals import HTMLFile
from ZWikiDefaults import DEFAULT_PAGE_TYPE
from ZWikiPage import ZWikiPage


########################################
# page creation

manage_addZWikiPageForm = HTMLFile('zwikipageAdd', globals())

def manage_addZWikiPage(self, id, title='', file='', REQUEST=None,
                        submit=None):
    """Add a ZWiki Page object with the contents of file. If
    'file' is empty, default text is used.
    """
    # XXX much like _create_page; compare/combine
    #_create_page(id,text,title=title)

    # don't bother with _create_page's default text and dtml shenanigans right now
    text = file
    if type(text) is not StringType: text=text.read()
    if not text:
        text = ''
#        if hasattr(self, 'standard_wiki_page'):
#            if callable(self.aq_parent.standard_wiki_page):
#                text = self.standard_wiki_page(self,REQUEST)
#            else:
#                text = HTML(self.standard_wiki_page)
#        else:
#            text = default_wiki_page

    ob=ZWikiPage(source_string=text, __name__=id)
    ob.page_type = DEFAULT_PAGE_TYPE
    ob.title=title
    id=self._setObject(id, ob)

    # 2.2-specific: the new page object is owned by the current
    # authenticated user, if any; not desirable for executable content.
    # Remove any such ownership so that the page will acquire it's
    # owner from the parent folder.
    ob._deleteOwnershipAfterAdd()
    #XXX or _owner=UnownableOwner ?


    # catalog code

    if REQUEST is not None:
        try: u=self.DestinationURL()
        except: u=REQUEST['URL1']
        if submit==" Add and Edit ": u="%s/%s" % (u,quote(id))
        REQUEST.RESPONSE.redirect(u+'/manage_main')
    return ''



########################################
# integrating zwiki web creation - CMFWiki stuff:

#def makeCMFWikiPage(id, title, file):
#    ob = CMFWikiPage(source_string=file, __name__=id)
#    ob.title = title
#    ob.parents = []
#    username = getSecurityManager().getUser().getUserName()
#    ob.manage_addLocalRoles(username, ['Owner'])
#    ob.setSubOwner('both')
#    initPageMetadata(ob)
#    for name, perm in ob._perms.items():
#        pseudoperm = default_perms[name]
#        local_roles_map = ob._local_roles_map
#        roles_map = ob._roles_map
#        roles = (local_roles_map[name],) + roles_map[pseudoperm]
#        ob.manage_permission(perm, roles=roles)
#    return ob
#
#def addCMFWikiPage(self, id, title='', file=''):
#    id=str(id)
#    title=str(title)
#    ob = makeCMFWikiPage(id, title, file)
#    self._setObject(id, ob)
#
#def addCMFWikiFolder(self, id, title=''):
#    id = str(id)
#    title = str(title)
#    ob = CMFWikiFolder(id, title)
#    id = self._setObject(id, ob)
#    ob = getattr(self, id)
#    p = package_home(globals()) + os.sep + 'default_wiki_content'
#    fnames = os.listdir(p)
#    for fname in fnames:
#        if fname[-5:] != '.wiki': continue
#        f = open(p + os.sep + fname, 'r')
#        fname = fname[:-5]
#        addCMFWikiPage(ob, fname, title='', file=f.read())
#        page = getattr(ob, fname)
#        page.indexObject()
#        # Hack - may be ok if we continue to have, like, only two pages:
#        if fname == 'SandBox':
#            page.parents = ['FrontPage']
