######################################################################
# product initialization

__doc__="""
ZWikiPage product
"""
__version__='0.9.4'

import ZWikiPage
# "Additionally, to be sure the permissions take effect you should add
# a Globals.default__class_init__() call after any class that has an
# __ac_permissions__ structure."
import Globals
Globals.default__class_init__(ZWikiPage)

#try:
#    import ZWikiTests
#    TestSuite = ZWikiTests.TestSuite
#except ImportError:
#    pass # ZUnit not installed


def initialize(context): 
    """Initialize the ZWiki product.
    """
    try: 
        # register classes associated with the product
        context.registerClass(
            ZWikiPage.ZWikiPage, 
            constructors = ( 
                ZWikiPage.manage_addZWikiPageForm,
                ZWikiPage.manage_addZWikiPage),
            icon = 'ZWikiPage_icon.gif'
            )
        # the docs suggest this to allow zclass-subclassing
        context.registerBaseClass(ZWikiPage.ZWikiPage)

    except:
        import sys, traceback, string
        type, val, tb = sys.exc_info()
        sys.stderr.write(string.join(traceback.format_exception(type, val, tb), ''))
        del type, val, tb
