import unittest
import simpletestrunner
import Zope
from Products.ZWiki.ZWikiPage import *

class ZWikiPageTests(simpletestrunner.TestCase):

    def setUp( self ):
        get_transaction().begin()
#        if not hasattr(self,'ZopeContext') or not self.ZopeContext:
#            self.ZopeContext = Zope.app()
#            self.used_app = 1

    def tearDown( self ):
#        if hasattr(self,'used_app'):
#            # from Zope.__init__, needed to prevent app() hanging
#            self.ZopeContext._p_jar.close()
#            del self.used_app # are these dels needed ?

        del self.ZopeContext   
        get_transaction().abort()


    def test_creation(self):
        """test zwiki page creation"""
        p = ZWikiPage()
        assert p.parents == []
        assert p.page_type == DEFAULT_PAGE_TYPE

    def test_ZWikiPage_mgmt(self):
        "test adding & deleting zwiki pages via the ZMI"
        zc = self.ZopeContext
        zc.manage_addProduct['ZWiki'].manage_addZWikiPage('TestPageB', \
                                                           title='test page', \
                                                           file='blah blah')
        assert hasattr(zc,'TestPageB'), 'page not created'
        assert zc.TestPageB.text() == 'blah blah', 'wrong text'
        assert zc.TestPageB.page_type == 'structuredtext', \
               'wrong default page type'
        zc.manage_delObjects(['TestPageB'])
        assert not hasattr(zc,'TestPageB'), 'page not deleted'


def test_suite():
    suite = simpletestrunner.TestSuite()
    suite.addTest(simpletestrunner.makeSuite(ZWikiPageTests))
    return suite

def run():
    unittest.TextTestRunner().run(test_suite())

if __name__ == '__main__':
    run()
